<!doctype html>
<html>
<head>
    <title>Tor 0.3.3.5-rc is released! | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.3.3.5-rc is released! | Tor Project">
    <meta property="og:description" content="There&#39;s a new release candidate available for download. If you build Tor from source, you can download the source code for 0.3.3.5-rc from the usual place on the website. If you don&#39;t build Tor from source, don&#39;t worry! Updated packages should be available over the coming weeks, with a new alpha Tor Browser release some time this week.">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-0335-rc-released/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.3.3.5-rc is released!
      </h1>
    <p class="meta">by nickm | April 15, 2018</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Hi! There's a new release candidate available for download. If you build Tor from source, you can download the source code for 0.3.3.5-rc from the usual place on the website. If you don't build Tor from source, don't worry! Updated packages should be available over the coming weeks, with a new alpha Tor Browser release some time this week.</p>
<p>Tor 0.3.3.5-rc fixes various bugs in earlier versions of Tor, including some that could affect reliability or correctness.</p>
<p>This is the first release candidate in the 0.3.3 series. If we find no new bugs or regression here, then the first stable 0.3.3 release will be nearly identical to this one.</p>
<h2>Changes in version 0.3.3.5-rc - 2018-04-15</h2>
<ul>
<li>Major bugfixes (security, protover, voting):
<ul>
<li>Revise Rust implementation of protover to use a more memory- efficient voting algorithm and corresponding data structures, thus avoiding a potential memory-based DoS attack where specially crafted protocol strings would expand to fill available memory. Fixes bug <a href="https://bugs.torproject.org/24031">24031</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Major bugfixes (performance, load balancing):
<ul>
<li>Directory authorities no longer vote in favor of the Guard flag for relays without directory support. Starting in Tor 0.3.0.1-alpha, clients have been avoiding using such relays in the Guard position, leading to increasingly broken load balancing for the 5%-or-so of Guards that don't advertise directory support. Fixes bug <a href="https://bugs.torproject.org/22310">22310</a>; bugfix on 0.3.0.6.</li>
</ul>
</li>
</ul>
<p> </p>
<!--break--><ul>
<li>Minor feature (continuous integration):
<ul>
<li>Update the Travis CI configuration to use the stable Rust channel, now that we have decided to require that. Closes ticket <a href="https://bugs.torproject.org/25714">25714</a>.</li>
</ul>
</li>
<li>Minor features (config options):
<ul>
<li>Change the way the default value for MaxMemInQueues is calculated. We now use 40% of the hardware RAM if the system has 8 GB RAM or more. Otherwise we use the former value of 75%. Closes ticket <a href="https://bugs.torproject.org/24782">24782</a>.</li>
</ul>
</li>
<li>Minor features (geoip):
<ul>
<li>Update geoip and geoip6 to the April 3 2018 Maxmind GeoLite2 Country database. Closes ticket <a href="https://bugs.torproject.org/25718">25718</a>.</li>
</ul>
</li>
<li>Minor bugfixes (client):
<ul>
<li>When using a listed relay as a bridge, and also using microdescriptors, and considering that relay as a non-bridge in a circuit, treat its microdescriptor as a valid source of information about that relay. This change should prevent a non- fatal assertion error. Fixes bug <a href="https://bugs.torproject.org/25691">25691</a>; bugfix on 0.3.3.4-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (controller):
<ul>
<li>Restore the correct operation of the RESOLVE command, which had been broken since we added the ability to enable/disable DNS on specific listener ports. Fixes bug <a href="https://bugs.torproject.org/25617">25617</a>; bugfix on 0.2.9.3-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (distribution, compilation, rust):
<ul>
<li>Build correctly when the rust dependencies submodule is loaded, but the TOR_RUST_DEPENDENCIES environment variable is not set. Fixes bug <a href="https://bugs.torproject.org/25679">25679</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Actually include all of our Rust source in our source distributions. (Previously, a few of the files were accidentally omitted.) Fixes bug <a href="https://bugs.torproject.org/25732">25732</a>; bugfix on 0.3.3.2-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (documentation):
<ul>
<li>Document that the PerConnBW{Rate,Burst} options will fall back to their corresponding consensus parameters only if those parameters are set. Previously we had claimed that these values would always be set in the consensus. Fixes bug <a href="https://bugs.torproject.org/25296">25296</a>; bugfix on 0.2.2.7-alpha.</li>
<li>Revert a misformatting issue in the ExitPolicy documentation. Fixes bug <a href="https://bugs.torproject.org/25582">25582</a>; bugfix on 0.3.3.1-alpha.</li>
</ul>
</li>
<li>Minor bugfixes (exit node DNS retries):
<ul>
<li>Re-attempt timed-out DNS queries 3 times before failure, since our timeout is 5 seconds for them, but clients wait 10-15. Also allow slightly more timeouts per resolver when an exit has multiple resolvers configured. Fixes bug <a href="https://bugs.torproject.org/21394">21394</a>; bugfix on 0.3.1.9.</li>
</ul>
</li>
<li>Minor bugfixes (onion services):
<ul>
<li>Re-instate counting the client HSDir fetch circuits against the MaxClientCircuitsPending rate limit. Fixes bug <a href="https://bugs.torproject.org/24989">24989</a>; bugfix on 0.3.3.1-alpha.</li>
<li>Remove underscores from the _HSLayer{2,3}Nodes options. This expert-user configuration can now be enabled as HSLayer{2,3}Nodes. Fixes bug <a href="https://bugs.torproject.org/25581">25581</a>; bugfix on 0.3.3.1-alpha</li>
</ul>
</li>
<li>Code simplification and refactoring:
<ul>
<li>Move the list of default directory authorities to its own file. Closes ticket <a href="https://bugs.torproject.org/24854">24854</a>. Patch by "beastr0".</li>
</ul>
</li>
<li>Documentation (manpage, denial of service):
<ul>
<li>Provide more detail about the denial-of-service options, by listing each mitigation and explaining how they relate. Closes ticket <a href="https://bugs.torproject.org/25248">25248</a>.</li>
</ul>
</li>
</ul>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-274925"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274925" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anony (not verified)</span> said:</p>
      <p class="date-time">April 17, 2018</p>
    </div>
    <a href="#comment-274925">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274925" class="permalink" rel="bookmark">Is it possible to help me…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Is it possible to help me further understand how Tor uses Unix Sockets (UDS)?  </p>
<p>If I set UnixSocksGroupWritable 1 in Torrc do I need to alter anything within the OS to make it work?  </p>
<p>And most important what are the inherent risk/reward structure for this use case? How will I know it's working?  Can it be used for hosting hidden services?</p>
<p>Is Tor generating Unix Internet Sockets? or Local Unix Sockets?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274934"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274934" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 18, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274925" class="permalink" rel="bookmark">Is it possible to help me…</a> by <span>Anony (not verified)</span></p>
    <a href="#comment-274934">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274934" class="permalink" rel="bookmark">If you use network,…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>If you use network, everything is managed by your firewall. If you use local files (sockets) everything is managed by unix file system permissions. Some people in some circumstances prefer to use socket files as they are much simpler to customize. However, firewall is much more powerful and flexible solution. </p>
<p>UnixSocksGroupWritable 1, AFAIR, just sets some permissions for socket file. If you want your application to use tor through sockets, this application must know how to do it. E.g., netcat and CoyIM can be used both with networks and socket connections, you can specify it. Not so many tools know how to use sockets.</p>
<p>If it works you can see new socket files created. You can test them with some applications for connectivity to tor.</p>
<p>At startup tor creates socket file(s) with some permissions (if you choose those Socks options from torrc).</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-274946"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274946" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">April 20, 2018</p>
    </div>
    <a href="#comment-274946">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274946" class="permalink" rel="bookmark">Isn&#039;t it funny that the…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Isn't it funny that the total number of bridges had a sharp decline starting on the date of this post (April 15)?<br />
<a href="https://metrics.torproject.org/networksize.html" rel="nofollow">https://metrics.torproject.org/networksize.html</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-274975"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274975" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Whiteshield (not verified)</span> said:</p>
      <p class="date-time">April 21, 2018</p>
    </div>
    <a href="#comment-274975">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274975" class="permalink" rel="bookmark">Кві 22 09:19:31.603 …</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>tor_bug_occurred_(): Bug: circuitbuild.c:2779: onion_extend_cpath: Non-fatal assertion info failed. (on Tor 0.3.3.5-rc 81d71f0d41adf0d8)<br />
Bug: Non-fatal assertion info failed in onion_extend_cpath at circuitbuild.c:2779. (Stack trace not available) (on Tor 0.3.3.5-rc 81d71f0d41adf0d8)<br />
Failed to find node for hop #2 of our path. Discarding this circuit.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-274984"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-274984" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  gk
  </article>
    <div class="comment-header">
      <p class="comment__submitted">gk said:</p>
      <p class="date-time">April 23, 2018</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-274975" class="permalink" rel="bookmark">Кві 22 09:19:31.603 …</a> by <span>Whiteshield (not verified)</span></p>
    <a href="#comment-274984">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-274984" class="permalink" rel="bookmark">See: https://trac.torproject…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>See: <a href="https://trac.torproject.org/projects/tor/ticket/25692" rel="nofollow">https://trac.torproject.org/projects/tor/ticket/25692</a> for the work we are doing in that regard.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-275344"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-275344" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>NP (not verified)</span> said:</p>
      <p class="date-time">May 15, 2018</p>
    </div>
    <a href="#comment-275344">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-275344" class="permalink" rel="bookmark">Uninformed question from a…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Uninformed question from a not so savvy but curious user: Could packets be split during transmission, follow different routes and be reconstituted at reception?</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
